function Run()
	local Level = CityGetLevel("")
	local DefaultID = GetID("")
	local City0ID = GetID("City0")
	local Hour = math.mod(GetGametime(), 24)
	
	if City0ID == -1 then
		local CityCount = ScenarioGetObjects("Settlement", 1, "City")
		City0ID = GetID("City0")
	end
	
	if Level==1 then
		-- kontor city - do nothing here
		return
	elseif Level==2 then
		citypinghour_CheckVillage()
	elseif Level==3 then
		citypinghour_CheckSmallTown()
	elseif Level==4 then
		citypinghour_CheckTown()
	elseif Level==5 then
		citypinghour_CheckCapital()
	elseif Level==6 then
		citypinghour_CheckCapital()
	end

	citypinghour_CheckMusicians()
	citypinghour_CheckCrimes()
	
	if DefaultID == City0ID then
		if ( Hour == 1 ) then
			citypinghour_StoreSimAges()
		end
		if ( Hour == 0 ) then
			citypinghour_CorrectSimAges()
		end
	end
end

function CheckMusicians()
	--ScenarioGetRandomObject("cl_Settlement","MusicianHomeCity")
	if not CityGetRandomBuilding("",3,23,-1,-1,FILTER_IGNORE,"MusicianHomeBuilding") then
		return
	end
	GetPosition("MusicianHomeBuilding","MusicianSpawnPos")
	if not AliasExists("#Musician1") then
		SimCreate(900,"MusicianHomeBuilding","MusicianSpawnPos","#Musician1")
		SimSetBehavior("#Musician1","Musician")
	end
	if not AliasExists("#Musician2") then
		SimCreate(901,"MusicianHomeBuilding","MusicianSpawnPos","#Musician2")
		SimSetBehavior("#Musician2","Musician")
	end
	if not AliasExists("#Musician3") then
		SimCreate(902,"MusicianHomeBuilding","MusicianSpawnPos","#Musician3")
		SimSetBehavior("#Musician3","Musician")
	end
	if not AliasExists("#Musician4") then
		SimCreate(905,"MusicianHomeBuilding","MusicianSpawnPos","#Musician4")
		SimSetBehavior("#Musician4","Musician")
	end
end

function CheckCrimes()
	ListCrimeReport("crime_report_list")		-- liste mit (DynastyID, ActorID, CrimeTotal) 
	
	-- modifizieren
	local TopBias = -1
	local TopReport = -1
	local TopDynastyID = -1
	local TopActorID = -1
	local TopCrimeTotal = -1
	
	local DepositionTopBias = -1
	local DepositionTopReport = -1
	local DepositionTopDynastyID = -1
	local DepositionTopActorID = -1
	local DepositionTopCrimeTotal = -1
		
	for iReport = 0,ListSize("crime_report_list")-1 do
		ListGetElement("crime_report_list",iReport,"crime_report")
		local DynastyID  = GetProperty("crime_report", "DynastyID")
		local ActorID	 = GetProperty("crime_report", "ActorID")
		local CrimeTotal = GetProperty("crime_report", "CrimeTotal")
		
		if GetAliasByID(ActorID,"_actor") then
			if SimCanBeCharged("_actor")==0 then
				if GetAliasByID(DynastyID,"_dyn") then
					for iMember = 0, DynastyGetMemberCount("_dyn")-1 do
						if DynastyGetMember("_dyn",iMember,"_sim") then
							if GetSettlementID("_sim")==GetID("") then
								local Bias = CrimeTotal * 10	-- 0.. ~200
								
								local Hours = GetHoursToNextTrial("")
								if Hours>16 then 
									Bias = Bias - Hours * 2	-- 
								end
								
								local DiplomaticState = DynastyGetDiplomacyState("_dyn", "_actor")
								
								if DiplomaticState> DIP_NEUTRAL then
									Bias = 0
								elseif DiplomaticState==DIP_FOE then
									Bias = Bias
								else
									Bias = Bias * ((100.0-GetFavorToDynasty("_dyn","_actor"))/100)
								end

								if GetImpactValue("_actor","HaveImmunity")==1 then
									if Bias>DepositionTopBias and Bias>0 then
										DepositionTopBias = Bias
										DepositionTopReport = iReport
										DepositionTopDynastyID = DynastyID
										DepositionTopActorID = GetID("_actor")
										DepositionTopCrimeTotal = CrimeTotal
									end
								else
									if Bias>TopBias and Bias>0 then
										TopBias = Bias
										TopReport = iReport
										TopDynastyID = DynastyID
										TopActorID = GetID("_actor")
										TopCrimeTotal = CrimeTotal
									end
								end
							end
						end
					end
				end
			end
		end
	end
	
	--OutputDebugString("Best Accuser in "..GetName("").." is "..TopDynastyID.." with "..TopBias.." pts (actor="..TopActorID..",crimetotal="..TopCrimeTotal..").\n")
	--OutputDebugString("Best Deposition in "..GetName("").." is "..DepositionTopDynastyID.." with "..DepositionTopBias.." pts (actor="..DepositionTopActorID..",crimetotal="..DepositionTopCrimeTotal..").\n")
	SetProperty("","Crimes_TopAccuserDynastyID",TopDynastyID)
	SetProperty("","Crimes_TopActorID",TopActorID)
	SetProperty("","Crimes_TopBias",TopBias)
	SetProperty("","Crimes_TopCrimeTotal",TopCrimeTotal)

	SetProperty("","Crimes_DepositionTopActorID",DepositionTopActorID)
end

function CheckVillage()

	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_TOWNHALL, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_PRISON, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_WELL, 1, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_LINGERPLACE, 1, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_SCHOOL, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_GRAVEYARD, -1)


	AICheckWorkingPlace("", GL_BUILDING_TYPE_RANGERHUT, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_FARM, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_MINE, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_TAVERN, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_HOSPITAL, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_BANK, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_CASTLE, 1)
	
	citypinghour_CheckChurch(1)
	
	local Mines		= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_MINE, -1, -1, FILTER_HAS_DYNASTY)
	local Farms		= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_FARM, -1, -1, FILTER_HAS_DYNASTY)
	local Rangers = CityGetBuildingCount("", -1, GL_BUILDING_TYPE_RANGERHUT, -1, -1, FILTER_HAS_DYNASTY)
	
	if Mines>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_SMITHY, 1)
	end
	
	if Farms>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_BAKERY, 1)
	end
	
	if Rangers>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_JOINERY, 1)
	end	
-- Nebelwerfer
        local NumBuildingsX = CityGetBuildingCount("", 6, 33, 2, -1, FILTER_IGNORE)
        CityGetBuildings("", 6, 33, 2, -1, FILTER_IGNORE, "BuildingX")
        for i=0, NumBuildingsX-1 do
            if GetState("BuildingX"..i, 46) == false then
               AddImpact("BuildingX"..i, "buildinggetnebel", 1, 0)
               SetState("BuildingX"..i, STATE_NEBEL, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end
        local NumBuildingsY = CityGetBuildingCount("", 6, 33, 1, -1, FILTER_IGNORE)
        CityGetBuildings("", 6, 33, 1, -1, FILTER_IGNORE, "BuildingY")
        for i=0, NumBuildingsY-1 do
            if GetState("BuildingY"..i, 46) == false then
               AddImpact("BuildingY"..i, "buildinggetnebel", 1, 0)
               SetState("BuildingY"..i, STATE_NEBEL, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end
-- Statuenbetrachter
        local NumStatuen = CityGetBuildingCount("", 7, 32, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 7, 32, -1, -1, FILTER_IGNORE, "Statue")
        for i=0, NumStatuen-1 do
            if GetState("Statue"..i, 50) == false then
               AddImpact("Statue"..i, "statuegetfans", 1, 24)
               SetState("Statue"..i, STATE_STATUENGUNST, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end

end

function CheckSmallTown()

	CitySetMaxWorkerhutLevel("", 2)

	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_TOWNHALL, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_MARKET, GL_BUILDING_TYPE_HARBOR, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_PRISON, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_WELL, 1, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_LINGERPLACE, 1, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_SCHOOL, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_GRAVEYARD, -1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_EXECUTIONS_PLACE, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_BANK, 1)

	AICheckWorkingPlace("", GL_BUILDING_TYPE_RANGERHUT, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_FARM, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_MINE, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_TAVERN, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_ALCHEMIST, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_HOSPITAL, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_BANK, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_CASTLE, 1)
	
	citypinghour_CheckChurch(1)
	
	local Mines		= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_MINE, -1, -1, FILTER_HAS_DYNASTY)
	local Farms		= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_FARM, -1, -1, FILTER_HAS_DYNASTY)
	local Rangers = CityGetBuildingCount("", -1, GL_BUILDING_TYPE_RANGERHUT, -1, -1, FILTER_HAS_DYNASTY)
	
	if Mines>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_SMITHY, 1)
	end
	
	if Farms>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_BAKERY, 1)
		AICheckWorkingPlace("", GL_BUILDING_TYPE_TAILORING, 1)
	end
	
	if Rangers>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_JOINERY, 1)
	end
	
	if not HasProperty("", "AI_Robber_Checked") then
		if AICheckWorkingPlace("", GL_BUILDING_TYPE_ROBBER, 1) then
			SetProperty("", "AI_Robber_Checked")
		end
	end
-- Nebelwerfer
        local NumBuildingsX = CityGetBuildingCount("", 6, 33, 2, -1, FILTER_IGNORE)
        CityGetBuildings("", 6, 33, 2, -1, FILTER_IGNORE, "BuildingX")
        for i=0, NumBuildingsX-1 do
            if GetState("BuildingX"..i, 46) == false then
               AddImpact("BuildingX"..i, "buildinggetnebel", 1, 0)
               SetState("BuildingX"..i, STATE_NEBEL, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end
        local NumBuildingsY = CityGetBuildingCount("", 6, 33, 1, -1, FILTER_IGNORE)
        CityGetBuildings("", 6, 33, 1, -1, FILTER_IGNORE, "BuildingY")
        for i=0, NumBuildingsY-1 do
            if GetState("BuildingY"..i, 46) == false then
               AddImpact("BuildingY"..i, "buildinggetnebel", 1, 0)
               SetState("BuildingY"..i, STATE_NEBEL, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end
-- Statuenbetrachter
        local NumStatuen = CityGetBuildingCount("", 7, 32, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 7, 32, -1, -1, FILTER_IGNORE, "Statue")
        for i=0, NumStatuen-1 do
            if GetState("Statue"..i, 50) == false then
               AddImpact("Statue"..i, "statuegetfans", 1, 24)
               SetState("Statue"..i, STATE_STATUENGUNST, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end

end

function CheckTown()

	CitySetMaxWorkerhutLevel("", 3)

	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_TOWNHALL, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_MARKET, GL_BUILDING_TYPE_HARBOR, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_PRISON, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_WELL, 1, 3)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_LINGERPLACE, 1, 4)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_SCHOOL, 1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_GRAVEYARD, -1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_EXECUTIONS_PLACE, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_BANK, 2)

	AICheckWorkingPlace("", GL_BUILDING_TYPE_RANGERHUT, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_FARM, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_MINE, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_TAVERN, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_ALCHEMIST, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_HOSPITAL, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_SMITHY, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_BANK, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_CASTLE, 1)
	
	citypinghour_CheckChurch(2)
		
	local Farms		= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_FARM, -1, -1, FILTER_HAS_DYNASTY)
	local Rangers = CityGetBuildingCount("", -1, GL_BUILDING_TYPE_RANGERHUT, -1, -1, FILTER_HAS_DYNASTY)
	
	if Farms>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_BAKERY, 1)
		AICheckWorkingPlace("", GL_BUILDING_TYPE_TAILORING, 1)
	end
		
	if Rangers>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_JOINERY, 1)
	end
	
	if not HasProperty("", "AI_Robber_Checked") then
		if AICheckWorkingPlace("", GL_BUILDING_TYPE_ROBBER, 1) then
			SetProperty("", "AI_Robber_Checked")
		end
	end

	if not HasProperty("", "AI_Thief_Checked") then
		if AICheckWorkingPlace("", GL_BUILDING_TYPE_THIEF, 1) then
			SetProperty("", "AI_Thief_Checked")
		end
	end
-- Nebelwerfer
        local NumBuildingsX = CityGetBuildingCount("", 6, 33, 2, -1, FILTER_IGNORE)
        CityGetBuildings("", 6, 33, 2, -1, FILTER_IGNORE, "BuildingX")
        for i=0, NumBuildingsX-1 do
            if GetState("BuildingX"..i, 46) == false then
               AddImpact("BuildingX"..i, "buildinggetnebel", 1, 0)
               SetState("BuildingX"..i, STATE_NEBEL, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end
        local NumBuildingsY = CityGetBuildingCount("", 6, 33, 1, -1, FILTER_IGNORE)
        CityGetBuildings("", 6, 33, 1, -1, FILTER_IGNORE, "BuildingY")
        for i=0, NumBuildingsY-1 do
            if GetState("BuildingY"..i, 46) == false then
               AddImpact("BuildingY"..i, "buildinggetnebel", 1, 0)
               SetState("BuildingY"..i, STATE_NEBEL, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end
-- Partykracher V4
    if CityGetLevel("")==5 then
        -- Rathaus
        local RatHausZahl = CityGetBuildingCount("", 3, 23, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 3, 23, -1, -1, FILTER_IGNORE, "RatPartyHaus")
        for i=0, RatHausZahl-1 do
             SetState("RatPartyHaus"..i, STATE_SILVESTER, true)
             Sleep(1)
        end
        -- Schule
        local UniHausZahl = CityGetBuildingCount("", 3, 27, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 3, 27, -1, -1, FILTER_IGNORE, "UniPartyHaus")
        for i=0, UniHausZahl-1 do
             SetState("UniPartyHaus"..i, STATE_SILVESTER, true)
             Sleep(1)
        end
        -- Markt
        local MkpHausZahl = CityGetBuildingCount("", 5, 14, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 5, 14, -1, -1, FILTER_IGNORE, "MkpPartyHaus")
        for i=0, MkpHausZahl-1 do
             SetState("MkpPartyHaus"..i, STATE_SILVESTER, true)
             Sleep(1)
        end
    end
-- Statuenbetrachter
        local NumStatuen = CityGetBuildingCount("", 7, 32, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 7, 32, -1, -1, FILTER_IGNORE, "Statue")
        for i=0, NumStatuen-1 do
            if GetState("Statue"..i, 50) == false then
               AddImpact("Statue"..i, "statuegetfans", 1, 24)
               SetState("Statue"..i, STATE_STATUENGUNST, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end

end

function CheckCapital()

	CitySetMaxWorkerhutLevel("", 3)

	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_TOWNHALL, 3)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_MARKET, GL_BUILDING_TYPE_HARBOR, 3)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_PRISON, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_WELL, 1, 3)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_LINGERPLACE, 1, 6)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_SCHOOL, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_GRAVEYARD, -1)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_TYPE_EXECUTIONS_PLACE, 2)
	citypinghour_CheckBuilding( GL_BUILDING_CLASS_PUBLICBUILDING, GL_BUILDING_BANK, 3)

	AICheckWorkingPlace("", GL_BUILDING_TYPE_RANGERHUT, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_FARM, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_MINE, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_TAVERN, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_ALCHEMIST, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_HOSPITAL, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_SMITHY, 2)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_BANK, 1)
	AICheckWorkingPlace("", GL_BUILDING_TYPE_CASTLE, 1)
	
	citypinghour_CheckChurch(2)
	
	local Farms		= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_FARM, -1, -1, FILTER_HAS_DYNASTY) + CityGetBuildingCount("", -1, GL_BUILDING_TYPE_FISHINGHUT, -1, -1, FILTER_HAS_DYNASTY)
	local Rangers = CityGetBuildingCount("", -1, GL_BUILDING_TYPE_RANGERHUT, -1, -1, FILTER_HAS_DYNASTY)
	
	if Farms>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_BAKERY, 1)
		AICheckWorkingPlace("", GL_BUILDING_TYPE_TAILORING, 1)
	end
	
	if Rangers>0 then
		AICheckWorkingPlace("", GL_BUILDING_TYPE_JOINERY, 1)
	end
	
	if not HasProperty("", "AI_Robber_Checked") then
		if AICheckWorkingPlace("", GL_BUILDING_TYPE_ROBBER, 1) then
			SetProperty("", "AI_Robber_Checked")
		end
	end

	if not HasProperty("", "AI_Thief_Checked") then
		if AICheckWorkingPlace("", GL_BUILDING_TYPE_THIEF, 1) then
			SetProperty("", "AI_Thief_Checked")
		end
	end
-- Nebelwerfer
        local NumBuildingsX = CityGetBuildingCount("", 6, 33, 2, -1, FILTER_IGNORE)
        CityGetBuildings("", 6, 33, 2, -1, FILTER_IGNORE, "BuildingX")
        for i=0, NumBuildingsX-1 do
            if GetState("BuildingX"..i, 46) == false then
               AddImpact("BuildingX"..i, "buildinggetnebel", 1, 0)
               SetState("BuildingX"..i, STATE_NEBEL, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end
        local NumBuildingsY = CityGetBuildingCount("", 6, 33, 1, -1, FILTER_IGNORE)
        CityGetBuildings("", 6, 33, 1, -1, FILTER_IGNORE, "BuildingY")
        for i=0, NumBuildingsY-1 do
            if GetState("BuildingY"..i, 46) == false then
               AddImpact("BuildingY"..i, "buildinggetnebel", 1, 0)
               SetState("BuildingY"..i, STATE_NEBEL, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end	
-- Partykracher V4
    if CityGetLevel("")==5 then
        -- Rathaus
        local RatHausZahl = CityGetBuildingCount("", 3, 23, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 3, 23, -1, -1, FILTER_IGNORE, "RatPartyHaus")
        for i=0, RatHausZahl-1 do
             SetState("RatPartyHaus"..i, STATE_SILVESTER, true)
             Sleep(1)
        end
        -- Schule
        local UniHausZahl = CityGetBuildingCount("", 3, 27, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 3, 27, -1, -1, FILTER_IGNORE, "UniPartyHaus")
        for i=0, UniHausZahl-1 do
             SetState("UniPartyHaus"..i, STATE_SILVESTER, true)
             Sleep(1)
        end
        -- Markt
        local MkpHausZahl = CityGetBuildingCount("", 5, 14, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 5, 14, -1, -1, FILTER_IGNORE, "MkpPartyHaus")
        for i=0, MkpHausZahl-1 do
             SetState("MkpPartyHaus"..i, STATE_SILVESTER, true)
             Sleep(1)
        end
    end
-- Statuenbetrachter
        local NumStatuen = CityGetBuildingCount("", 7, 32, -1, -1, FILTER_IGNORE)
        CityGetBuildings("", 7, 32, -1, -1, FILTER_IGNORE, "Statue")
        for i=0, NumStatuen-1 do
            if GetState("Statue"..i, 50) == false then
               AddImpact("Statue"..i, "statuegetfans", 1, 24)
               SetState("Statue"..i, STATE_STATUENGUNST, true)
               Sleep(1)
            else
               Sleep(1)
            end
        end

end

function CheckBuilding(Class, Type, Level, Count)

	if not Count then
		Count = 1
	end
	
	local	BuildTotal = CityGetBuildings("", Class, Type, -1, -1, FILTER_IGNORE, "Found")
	local	Ist = 0
	
	for l=0,BuildTotal-1 do
		if BuildingGetLevel("Found"..l) >= Level then
			Ist = Ist + 1
			if Ist >= Count then
				return
			end
		end
	end
	
	for l=0,BuildTotal-1 do
		if BuildingGetLevel("Found"..l) < Level then
			BuildingLevelMeUp("Found"..l, -1)
			Ist = Ist + 1
			if Ist>=Count then
				return
			end
		end
	end
	
	while Ist < Count do
		local Proto = ScenarioFindBuildingProto(Class, Type, Level, -1)
		if not Proto or Proto==-1 then
			break
		end

		if not CityBuildNewBuilding("", Proto, nil, "Building") then
			break
		end
		Ist = Ist + 1
	end

end

function CheckChurch(MaxCount)
	local ChEv			= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_CHURCH_EV, -1, -1, FILTER_HAS_DYNASTY)
	local ChCa			= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_CHURCH_CATH, -1, -1, FILTER_HAS_DYNASTY)

	if ChEv + ChCa < MaxCount then
		-- no church, so create one
	
		local TotalChEv	= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_CHURCH_EV, -1, -1, FILTER_NO_DYNASTY)
		local TotalChCa	= CityGetBuildingCount("", -1, GL_BUILDING_TYPE_CHURCH_CATH, -1, -1, FILTER_NO_DYNASTY)
	
		if TotalChEv>0 and TotalChCa==0 then
			AICheckWorkingPlace("", GL_BUILDING_TYPE_CHURCH_EV, ChEv+1)
		elseif TotalChCa>0 and TotalChEv==0 then
			AICheckWorkingPlace("", GL_BUILDING_TYPE_CHURCH_CATH, ChCa+1)
		else
			if Rand(100) < 50 then
				AICheckWorkingPlace("", GL_BUILDING_TYPE_CHURCH_EV, ChEv+1)
			else
				AICheckWorkingPlace("", GL_BUILDING_TYPE_CHURCH_CATH, ChCa+1)
			end
		end
	end
end

function StoreSimAges()
	local SimCount
	local LogMsgStr = "CityPingHour.lua : StoreSimAges() : "
	
	SimCount = ScenarioGetObjects("cl_Sim", 999999, "SimAr")
	LogMessage(LogMsgStr.."Storing ages of "..SimCount.." sims.")
	
	for i=0,SimCount-1 do
		LogMessage(LogMsgStr.."Setting age for "..GetName("SimAr"..i).." to "..SimGetAge("SimAr"..i))
		SetProperty("SimAr"..i, "sdk_OldAge", SimGetAge("SimAr"..i))
	end
end

function ProcessSimAge(SIM, YEARS)
	local SimOldAge
	local SimNewAge
	local LogMessageStr = "CityPingHour.lua : ProcessSimAge() : "
	
	LogMessage(LogMessageStr.."- Sim "..GetName(SIM).." OldAge is "..SimGetAge(SIM))
	
	--First lets check if the last age has been stored.
	if not HasProperty(SIM, "sdk_OldAge") then
		SimOldAge = SimGetAge(SIM) - YEARS - 1
	else
		SimOldAge = GetProperty(SIM, "sdk_OldAge")
	end
	-- Now lets check if it has been processed.
	if HasProperty(SIM, "sdk_CorYear") then
		-- Was processed last year ?
		if GetProperty(SIM, "sdk_CorYear") ~= GetYear() then
			SimNewAge = SimOldAge + 1
			SimSetAge(SIM, SimNewAge)
			LogMessage(LogMessageStr.."Setting age of "..GetName(SIM).." to "..SimNewAge)
			SetProperty(SIM, "sdk_CorYear", GetYear())
		else
			LogMessage(LogMessageStr.."Sim "..GetName(SIM).." was processed in year "..GetProperty(SIM, "sdk_CorYear"))
		end
	else
		SimNewAge = SimOldAge + 1
	if SimNewAge < 0 then
		SimSetAge(SIM, 1)
           else
		SimSetAge(SIM, SimNewAge)
	end
		LogMessage(LogMessageStr.."Setting age of "..GetName(SIM).." to "..SimNewAge)
		SetProperty(SIM, "sdk_CorYear", GetYear())
	end

end

function CorrectSimAges()
	local SimCount
	local YearsPerRound = GetSettingNumber("ENDLESS", "YearsPerRound", 1)
	local LogMsgStr = "CityPingHour.lua : CorrectSimAges() : "

	SimCount = ScenarioGetObjects("cl_Sim", 999999, "SimAr")
	
	LogMessage(LogMsgStr.."Correcting ages of "..SimCount.." sims.")
	
	for i=0,SimCount-1 do
		citypinghour_ProcessSimAge("SimAr"..i, YearsPerRound)
	end
end

